#include "table.h"

struct tmpl template[] = {
{ lu, {ANYEA,DN}, EAREGS, 0xD000, 0x0 },        /* 0 = add */
{ lu, {DN,ALTMEM}, REGEAS, 0xD100, 0x0 },
{ lu, {ANYEA,AN}, EAREG, 0xD1C0, 0x0 },
{ lu, {ANYEA,AN}, EAREG, 0xD1C0, 0x0 },        /* 3 = adda */
{ lu, {IMMED,DN}, IMMEAS, 0x0600, 0x0 },        /* 4 = addi */
{ lu, {IMMED,ALTER}, QUKEA, 0x5000, 0x0 },        /* 5 = addq */
{ lu, {DN,DN}, RXRYS, 0xD100, 0x0 },        /* 6 = addx */
{ lu, {DATA,DN}, EAREGS, 0xC000, 0x0 },        /* 7 = and */
{ lu, {DN,ALTMEM}, REGEAS, 0xC100, 0x0 },
{ lu, {IMMED,DN}, IMMEAS, 0x0200, 0x0 },        /* 9 = andi */
{ lu, {DN,DN}, RSHIFT, 0xE120, 0x0 },        /* 10 = asl */
{ lu, {IMMED,DN}, QSHIFT, 0xE100, 0x0 },
{ lu, {DN,DN}, RSHIFT, 0xE020, 0x0 },        /* 12 = asr */
{ lu, {IMMED,DN}, QSHIFT, 0xE000, 0x0 },
{ wlu, {EXPR}, BCC, 0x6400, 0x0 },        /* 14 = bcc */
{ wlu, {EXPR}, BCC, 0x6500, 0x0 },        /* 15 = bcs */
{ wlu, {EXPR}, BCC, 0x6700, 0x0 },        /* 16 = beq */
{ wlu, {EXPR}, BCC, 0x6C00, 0x0 },        /* 17 = bge */
{ wlu, {EXPR}, BCC, 0x6E00, 0x0 },        /* 18 = bgt */
{ wlu, {EXPR}, BCC, 0x6200, 0x0 },        /* 19 = bhi */
{ wlu, {EXPR}, BCC, 0x6F00, 0x0 },        /* 20 = ble */
{ wlu, {EXPR}, BCC, 0x6300, 0x0 },        /* 21 = bls */
{ wlu, {EXPR}, BCC, 0x6D00, 0x0 },        /* 22 = blt */
{ wlu, {EXPR}, BCC, 0x6B00, 0x0 },        /* 23 = bmi */
{ wlu, {EXPR}, BCC, 0x6600, 0x0 },        /* 24 = bne */
{ wlu, {EXPR}, BCC, 0x6A00, 0x0 },        /* 25 = bpl */
{ wlu, {EXPR}, BCC, 0x6800, 0x0 },        /* 26 = bvc */
{ wlu, {EXPR}, BCC, 0x6900, 0x0 },        /* 27 = bvs */
{ wlu, {EXPR}, BCC, 0x6000, 0x0 },        /* 28 = bra */
{ wlu, {EXPR}, BCC, 0x6100, 0x0 },        /* 29 = bsr */
{ lu, {DN,DN}, REGEA, 0x0140, 0x0 },        /* 30 = bchg */
{ lu, {IMMED,DN}, BIT, 0x0840, 0x0 },
{ bu, {DN,ALTMEM}, REGEA, 0x0140, 0x0 },
{ bu, {IMMED,ALTMEM}, BIT, 0x0840, 0x0 },
{ lu, {DN,DN}, REGEA, 0x0180, 0x0 },        /* 34 = bclr */
{ lu, {IMMED,DN}, BIT, 0x0880, 0x0 },
{ bu, {DN,ALTMEM}, REGEA, 0x0180, 0x0 },
{ bu, {IMMED,ALTMEM}, BIT, 0x0880, 0x0 },
{ lu, {DN,DN}, REGEA, 0x01C0, 0x0 },        /* 38 = bset */
{ lu, {IMMED,DN}, BIT, 0x08C0, 0x0 },
{ bu, {DN,ALTMEM}, REGEA, 0x01C0, 0x0 },
{ bu, {IMMED,ALTMEM}, BIT, 0x08C0, 0x0 },
{ lu, {DN,DN}, REGEA, 0x0100, 0x0 },        /* 42 = btst */
{ lu, {IMMED,DN}, BIT, 0x0800, 0x0 },
{ bu, {DN,DATA}, REGEA, 0x0100, 0x0 },
{ bu, {IMMED,DATA}, BIT, 0x0800, 0x0 },
{ bwlu, {DATALT}, EAS, 0x4200, 0x0 },        /* 46 = clr */
{ lu, {ANYEA,DN}, EAREGS, 0xB000, 0x0 },        /* 47 = cmp */
{ lu, {ANYEA,AN}, EAREG, 0xB1C0, 0x0 },        /* 48 = cmpa */
{ lu, {IMMED,DATA}, IMMEAS, 0x0C00, 0x0 },        /* 49 = cmpi */
{ lu, {DN,DATALT}, REGEAS, 0xB100, 0x0 },        /* 50 = eor */
{ lu, {IMMED,DN}, IMMEAS, 0x0A00, 0x0 },        /* 51 = eori */
{ W, {DN}, REG, 0x4880, 0x0 },        /* 52 = ext */
{ lu, {DN}, REG, 0x48C0, 0x0 },
{ lu, {DN}, REG, 0x49C0, 0x0 },        /* 54 = extb */
{ U, {EMPTY}, INH, 0x4AC8, 0x0 },        /* 55 = halt */
{ U, {EMPTY}, INH, 0x4AFC, 0x0 },        /* 56 = illegal */
{ U, {CONTROL}, EA, 0x4EC0, 0x0 },        /* 57 = jmp */
{ U, {CONTROL}, EA, 0x4E80, 0x0 },        /* 58 = jsr */
{ lu, {CONTROL,AN}, EAREG, 0x41C0, 0x0 },        /* 59 = lea */
{ wu, {AN,IMMED}, REGIMM, 0x4E50, 0x0 },        /* 60 = link */
{ wu, {ALTMEM}, EA, 0xE3C0, 0x0 },        /* 61 = lsl */
{ lu, {DN,DN}, RSHIFT, 0xE128, 0x0 },
{ lu, {IMMED,DN}, QSHIFT, 0xE108, 0x0 },
{ wu, {ALTMEM}, EA, 0xE2C0, 0x0 },        /* 64 = lsr */
{ lu, {DN,DN}, RSHIFT, 0xE028, 0x0 },
{ lu, {IMMED,DN}, QSHIFT, 0xE008, 0x0 },
{ wu, {ANYEA,DATALT}, MOVE, 0x3000, 0x0 },        /* 67 = move */
{ B, {DATA,DATALT}, MOVE, 0x1000, 0x0 },
{ L, {ANYEA,DATALT}, MOVE, 0x2000, 0x0 },
{ wu, {ANYEA,AN}, MOVE, 0x3000, 0x0 },
{ L, {ANYEA,AN}, MOVE, 0x2000, 0x0 },
{ wu, {CCR,DN}, EAREV, 0x42C0, 0x0 },
{ wu, {DN,CCR}, EA, 0x44C0, 0x0 },
{ wu, {IMMED,CCR}, EA, 0x44C0, 0x0 },
{ wu, {SR,DATALT}, EAREV, 0x40C0, 0x0 },
{ wu, {DATA,SR}, EA, 0x46C0, 0x0 },
{ lu, {CN,AN}, MOVEU, 0x4E68, 0x0 },
{ lu, {AN,CN}, MOVEU, 0x4E60, 0x0 },
{ wu, {ANYEA,AN}, MOVE, 0x3000, 0x0 },        /* 79 = movea */
{ L, {ANYEA,AN}, MOVE, 0x2000, 0x0 },
{ lu, {RN,CN}, MOVEC, 0x4E7B, 0x0 },        /* 81 = movec */
{ lu, {RN,ANI}, MOVEMO, 0x48C0, 0x0 },        /* 82 = movem */
{ lu, {RN,INDEX}, MOVEMO, 0x48C0, 0x0 },
{ lu, {RLIST,ANI}, MOVEMO, 0x48C0, 0x0 },
{ lu, {RLIST,INDEX}, MOVEMO, 0x48C0, 0x0 },
{ lu, {ANI,RN}, MOVEMI, 0x4CC0, 0x0 },
{ lu, {INDEX,RN}, MOVEMI, 0x4CC0, 0x0 },
{ lu, {ANI,RLIST}, MOVEMI, 0x4CC0, 0x0 },
{ lu, {INDEX,RLIST}, MOVEMI, 0x4CC0, 0x0 },
{ lu, {IMMED,DN}, MOVEQ, 0x7000, 0x0 },        /* 90 = moveq */
{ W, {DATA,DN}, EAREG, 0xC1C0, 0x0 },        /* 91 = muls */
{ lu, {DN,DN}, MULDIV, 0x4C00, 0x0800 },
{ lu, {ANI,DN}, MULDIV, 0x4C00, 0x0800 },
{ lu, {PSTINC,DN}, MULDIV, 0x4C00, 0x0800 },
{ lu, {PREDEC,DN}, MULDIV, 0x4C00, 0x0800 },
{ lu, {INDEX,DN}, MULDIV, 0x4C00, 0x0800 },
{ W, {DATA,DN}, EAREG, 0xC0C0, 0x0 },        /* 97 = mulu */
{ lu, {DN,DN}, MULDIV, 0x4C00, 0x0000 },
{ lu, {ANI,DN}, MULDIV, 0x4C00, 0x0000 },
{ lu, {PSTINC,DN}, MULDIV, 0x4C00, 0x0000 },
{ lu, {PREDEC,DN}, MULDIV, 0x4C00, 0x0000 },
{ lu, {INDEX,DN}, MULDIV, 0x4C00, 0x0000 },
{ lu, {DN}, EAS, 0x4400, 0x0 },        /* 103 = neg */
{ lu, {DN}, EAS, 0x4000, 0x0 },        /* 104 = negx */
{ U, {EMPTY}, INH, 0x4E71, 0x0 },        /* 105 = nop */
{ lu, {DN}, EAS, 0x4600, 0x0 },        /* 106 = not */
{ lu, {DATA,DN}, EAREGS, 0x8000, 0x0 },        /* 107 = or */
{ lu, {DN,ALTMEM}, REGEAS, 0x8100, 0x0 },
{ lu, {IMMED,DN}, IMMEAS, 0x0000, 0x0 },        /* 109 = ori */
{ lu, {CONTROL}, EA, 0x4840, 0x0 },        /* 110 = pea */
{ U, {EMPTY}, INH, 0x4BCC, 0x0 },        /* 111 = pulse */
{ U, {EMPTY}, INH, 0x4E73, 0x0 },        /* 112 = rte */
{ U, {EMPTY}, INH, 0x4E75, 0x0 },        /* 113 = rts */
{ bu, {DN}, EA, 0x54C0, 0x0 },        /* 114 = scc */
{ bu, {DN}, EA, 0x55C0, 0x0 },        /* 115 = scs */
{ bu, {DN}, EA, 0x57C0, 0x0 },        /* 116 = seq */
{ bu, {DN}, EA, 0x51C0, 0x0 },        /* 117 = sf */
{ bu, {DN}, EA, 0x5CC0, 0x0 },        /* 118 = sge */
{ bu, {DN}, EA, 0x5EC0, 0x0 },        /* 119 = sgt */
{ bu, {DN}, EA, 0x52C0, 0x0 },        /* 120 = shi */
{ bu, {DN}, EA, 0x5FC0, 0x0 },        /* 121 = sle */
{ bu, {DN}, EA, 0x53C0, 0x0 },        /* 122 = sls */
{ bu, {DN}, EA, 0x5DC0, 0x0 },        /* 123 = slt */
{ bu, {DN}, EA, 0x5BC0, 0x0 },        /* 124 = smi */
{ bu, {DN}, EA, 0x56C0, 0x0 },        /* 125 = sne */
{ bu, {DN}, EA, 0x5AC0, 0x0 },        /* 126 = spl */
{ bu, {DN}, EA, 0x50C0, 0x0 },        /* 127 = st */
{ bu, {DN}, EA, 0x58C0, 0x0 },        /* 128 = svc */
{ bu, {DN}, EA, 0x59C0, 0x0 },        /* 129 = svs */
{ U, {IMMED}, IMMW, 0x4E72, 0x0 },        /* 130 = stop */
{ lu, {ANYEA,DN}, EAREGS, 0x9000, 0x0 },        /* 131 = sub */
{ lu, {DN,ALTMEM}, REGEAS, 0x9100, 0x0 },
{ lu, {ANYEA,AN}, EAREG, 0x91C0, 0x0 },
{ lu, {ANYEA,AN}, EAREG, 0x91C0, 0x0 },        /* 134 = suba */
{ lu, {IMMED,DN}, IMMEAS, 0x0400, 0x0 },        /* 135 = subi */
{ lu, {IMMED,ALTER}, QUKEA, 0x5100, 0x0 },        /* 136 = subq */
{ lu, {DN,DN}, RXRYS, 0x9100, 0x0 },        /* 137 = subx */
{ wu, {DN}, REG, 0x4840, 0x0 },        /* 138 = swap */
{ U, {IMMED}, IMM4, 0x4E40, 0x0 },        /* 139 = trap */
{ U, {EMPTY}, INH, 0x51FA, 0x0 },        /* 140 = trapf */
{ wlu, {IMMED}, TRAPCC, 0x51F8, 0x0 },
{ bwlu, {ANYEA}, EAS, 0x4A00, 0x0 },        /* 142 = tst */
{ U, {AN}, REG, 0x4E58, 0x0 },        /* 143 = unlk */
{ bwlu, {ALTMEM}, EAS, 0xF400, 0x0 },        /* 144 = wddata */
{ lu, {ANI}, WDEBUG, 0xFBC0, 0x0003 },        /* 145 = wdebug */
{ lu, {INDEX}, WDEBUG, 0xFBC0, 0x0003 },
{ U, {EXPR}, EQU, 0x0, 0x0 },        /* 147 = equ */
{ bwlu, {MULTI}, DC, 0x0, 0x0 },        /* 148 = dc */
{ U, {EMPTY}, OPT, 0x0, 0x0 },        /* 149 = opt */
{ U, {EXPR}, RORG, 0x0, 0x0 },        /* 150 = rorg */
{ U, {EXPR}, ORG, 0x0, 0x0 },        /* 151 = org */
{ anysz, {EXPR}, DS, 0x0, 0x0 },        /* 152 = ds */
{ U, {EXPR}, ALIGN, 0x0, 0x0 },        /* 153 = align */
{ U, {EMPTY}, INCLUDE, 0x0, 0x0 },        /* 154 = include */
{ U, {EMPTY}, NULL_OP, 0x0, 0x0 },        /* 155 = xref */
{ U, {EMPTY}, NULL_OP, 0x0, 0x0 },        /* 156 = xdef */
{ U, {EMPTY}, NULL_OP, 0x0, 0x0 },        /* 157 = end */
{ U, {EMPTY}, NULL_OP, 0x0, 0x0 },        /* 158 = nam */
{ U, {EMPTY}, NULL_OP, 0x0, 0x0 },        /* 159 = name */
{ U, {EMPTY}, NULL_OP, 0x0, 0x0 },        /* 160 = pag */
{ U, {EMPTY}, NULL_OP, 0x0, 0x0 },        /* 161 = page */
{ U, {EMPTY}, NULL_OP, 0x0, 0x0 },        /* 162 = spc */
{ U, {EMPTY}, NULL_OP, 0x0, 0x0 },        /* 163 = ttl */
{ U, {EMPTY}, NULL_OP, 0x0, 0x0 },        /* 164 = idnt */
{ U, {EMPTY}, NULL_OP, 0x0, 0x0 },        /* 165 = section */
{ U, {EMPTY}, NULL_OP, 0x0, 0x0 },        /* 166 = plen */
{ U, {EMPTY}, NULL_OP, 0x0, 0x0 },        /* 167 = llen */
};

/*  112 mnemonics, 168 templates  */

struct mne mnemonic[] = {
{"add", 3, &template[0]},
{"adda", 1, &template[3]},
{"addi", 1, &template[4]},
{"addq", 1, &template[5]},
{"addx", 1, &template[6]},
{"align", 1, &template[153]},
{"and", 2, &template[7]},
{"andi", 1, &template[9]},
{"asl", 2, &template[10]},
{"asr", 2, &template[12]},
{"bcc", 1, &template[14]},
{"bchg", 4, &template[30]},
{"bclr", 4, &template[34]},
{"bcs", 1, &template[15]},
{"beq", 1, &template[16]},
{"bge", 1, &template[17]},
{"bgt", 1, &template[18]},
{"bhi", 1, &template[19]},
{"ble", 1, &template[20]},
{"bls", 1, &template[21]},
{"blt", 1, &template[22]},
{"bmi", 1, &template[23]},
{"bne", 1, &template[24]},
{"bpl", 1, &template[25]},
{"bra", 1, &template[28]},
{"bset", 4, &template[38]},
{"bsr", 1, &template[29]},
{"btst", 4, &template[42]},
{"bvc", 1, &template[26]},
{"bvs", 1, &template[27]},
{"clr", 1, &template[46]},
{"cmp", 1, &template[47]},
{"cmpa", 1, &template[48]},
{"cmpi", 1, &template[49]},
{"dc", 1, &template[148]},
{"ds", 1, &template[152]},
{"end", 1, &template[157]},
{"eor", 1, &template[50]},
{"eori", 1, &template[51]},
{"equ", 1, &template[147]},
{"ext", 2, &template[52]},
{"extb", 1, &template[54]},
{"halt", 1, &template[55]},
{"idnt", 1, &template[164]},
{"illegal", 1, &template[56]},
{"include", 1, &template[154]},
{"jmp", 1, &template[57]},
{"jsr", 1, &template[58]},
{"lea", 1, &template[59]},
{"link", 1, &template[60]},
{"llen", 1, &template[167]},
{"lsl", 3, &template[61]},
{"lsr", 3, &template[64]},
{"move", 12, &template[67]},
{"movea", 2, &template[79]},
{"movec", 1, &template[81]},
{"movem", 8, &template[82]},
{"moveq", 1, &template[90]},
{"muls", 6, &template[91]},
{"mulu", 6, &template[97]},
{"nam", 1, &template[158]},
{"name", 1, &template[159]},
{"neg", 1, &template[103]},
{"negx", 1, &template[104]},
{"nop", 1, &template[105]},
{"not", 1, &template[106]},
{"opt", 1, &template[149]},
{"or", 2, &template[107]},
{"org", 1, &template[151]},
{"ori", 1, &template[109]},
{"pag", 1, &template[160]},
{"page", 1, &template[161]},
{"pea", 1, &template[110]},
{"plen", 1, &template[166]},
{"pulse", 1, &template[111]},
{"rorg", 1, &template[150]},
{"rte", 1, &template[112]},
{"rts", 1, &template[113]},
{"scc", 1, &template[114]},
{"scs", 1, &template[115]},
{"section", 1, &template[165]},
{"seq", 1, &template[116]},
{"sf", 1, &template[117]},
{"sge", 1, &template[118]},
{"sgt", 1, &template[119]},
{"shi", 1, &template[120]},
{"sle", 1, &template[121]},
{"sls", 1, &template[122]},
{"slt", 1, &template[123]},
{"smi", 1, &template[124]},
{"sne", 1, &template[125]},
{"spc", 1, &template[162]},
{"spl", 1, &template[126]},
{"st", 1, &template[127]},
{"stop", 1, &template[130]},
{"sub", 3, &template[131]},
{"suba", 1, &template[134]},
{"subi", 1, &template[135]},
{"subq", 1, &template[136]},
{"subx", 1, &template[137]},
{"svc", 1, &template[128]},
{"svs", 1, &template[129]},
{"swap", 1, &template[138]},
{"trap", 1, &template[139]},
{"trapf", 2, &template[140]},
{"tst", 1, &template[142]},
{"ttl", 1, &template[163]},
{"unlk", 1, &template[143]},
{"wddata", 1, &template[144]},
{"wdebug", 2, &template[145]},
{"xdef", 1, &template[156]},
{"xref", 1, &template[155]},
{0}
};
int Nmne = (sizeof(mnemonic)/sizeof(mnemonic[0]))-1;
